functor Burglary() =
struct
open GM;
structure Eng : INFERENCE = NaiveInfer
structure IP = IPotential

val [FALSE, TRUE] = List.map RVar.intToValue [0,1] 
val [E,B,R,A,C] = List.map RVar.newVar [2,2,2,2,2]
val _ = RVar.giveName E "Earthquake"
val _ = RVar.giveName B "Burglary"
val _ = RVar.giveName R "Radio Announcement"
val _ = RVar.giveName A "Alarm"
val _ = RVar.giveName C "Neighbor call"

(* numbers are in wrong order!!!!*)
val cpds = List.map CPD.make
		    [([0.1, 0.9], E, []),
		     ([0.01, 0.99], B, []),
		     ([0.65, 0.01, 0.35, 0.99], R, [E]),
		     ([0.95, 0.8, 0.3, 0.001, 0.05, 0.2, 0.7, 0.999], A, [B,E]),
		     ([0.7, 0.05, 0.3, 0.95], C, [A])] 

val local_factors = List.map LocalFactor.CPD cpds
val gmodel = GModel.make local_factors

(* Pop up a display showing the model *)
val _ = Util.showDot (GModel.toDotString gmodel)

val engine = Eng.makeEngine (gmodel, [], [])
val engine = Eng.enterEvidence engine (Eng.Hard (C, FALSE))

val mE = Eng.query engine [E]
val mB = Eng.query engine [B]

val engine = Eng.enterEvidence engine (Eng.Hard (R, FALSE))
val mE' = Eng.query engine [E]
val mB' = Eng.query engine [B]

end
