(* INFERENCE : An interface for running inference on a graphical model *)
signature INFERENCE = 
sig
    structure GModel : D_G_MODEL
    structure RVar : D_R_VAR
    structure IP : D_IPOTENTIAL (* PRIVTE *)
    sharing RVar = GModel.RVar  = IP.RVar
    and GModel.IP = IP

    exception Error of string

    type engine

    datatype evidence = Hard of RVar.var * RVar.value
		      | Soft of IP.ipot

    (* makeEngine : Graphical model * query nodes * evidence nodes
			     -> engine *)
    val makeEngine : (GModel.gmodel * RVar.var list * RVar.var list) -> engine

    val enterEvidence : engine -> evidence -> engine
						    
    val query : engine -> RVar.var list -> IP.ipot
end
