functor NaiveInferFn(structure GModel : D_G_MODEL
		     structure RVar : D_R_VAR
		     structure IP : D_IPOTENTIAL
		     sharing GModel.RVar = RVar
		     and GModel.IP = IP)
	:> INFERENCE where GModel = GModel 
                     and IP = IP
		     and RVar = RVar = 
struct

structure GModel = GModel
structure RVar = RVar
structure IP = IP
structure RVarSet = ListSetFn(struct 
			     type ord_key = RVar.var
			     val compare = RVar.compare 
			     end)

exception Error of string

type engine = GModel.gmodel  

datatype evidence = Hard of RVar.var * RVar.value
		  | Soft of IP.ipot

fun makeEngine (gmodel,_,_) = gmodel

fun enterEvidence gmodel (Hard (var,value) ) =
    let  (*HACK, represent this as soft evidence *)
	val observed_index = RVar.valueToInt value
	val table = List.tabulate (RVar.dim var, fn i => if i = observed_index
							 then 1.0
							 else 0.0)
	val ipot = IP.make([var], table)
    in
	GModel.addIPotential gmodel ipot
    end
  | enterEvidence gmodel (Soft ipot) = GModel.addIPotential gmodel ipot

fun query gmodel qvars =
    let
	val (f::fs) = GModel.getIPotentials gmodel

	val scope = List.foldr (fn (f,s)=>RVarSet.addList(s, IP.scope f)) 
			       RVarSet.empty (f::fs)
	val evars = RVarSet.difference(scope, RVarSet.addList(RVarSet.empty,qvars))
	val fullF = List.foldr (fn (f,f')=> IP.multiply f f') 
			       f fs
	val margF = IP.marginalize fullF (RVarSet.listItems evars)

	val (normalized,z) = IP.normalize margF

    in 
	normalized
    end

end
