functor VarElimInferFn(structure GModel : D_G_MODEL
		       structure RVar : D_R_VAR
		       structure IP : D_IPOTENTIAL
		       sharing GModel.RVar = RVar 
		       and GModel.IP = IP )
	  :> INFERENCE where GModel = GModel
                       and IP = IP
		       and RVar = RVar = 
struct

structure GModel = GModel
structure IP = IP
structure RVar = RVar

exception Error of string

type engine = GModel.gmodel (* maintain the evidence *)

datatype evidence = Hard of RVar.var * RVar.value
		  | Soft of IP.ipot

fun makeEngine (gmodel,_,_) = gmodel

fun enterEvidence gmodel (Hard (var,value) ) = 
    let  (*HACK, represent this as soft evidence *)
	val observed_index = RVar.valueToInt value
	val table = List.tabulate (RVar.dim var, fn i => if i = observed_index
							 then 1.0
							 else 0.0)
	val ipot = IP.make([var], table)
    in
	GModel.addIPotential gmodel ipot
    end
  | enterEvidence gmodel (Soft ipot) = GModel.addIPotential gmodel ipot

fun query gmodel qvars = IP.varElim (GModel.getIPotentials gmodel) qvars

end
