(* PARAM_LEARN : An interface for learning in a graphical model 

   This is just a skeleton right now to illustrate Top down
   development with functors 
*)
signature PARAM_LEARN =
sig

    structure GModel : D_G_MODEL
    structure RVar : D_R_VAR
    structure IP : D_IPOTENTIAL (* PRIVATE *)
    sharing RVar = GModel.RVar  = IP.RVar
    and GModel.IP = IP

    exception Error of string

    type learner
    type parameters (* this might need to be implemented elsewhere *)

    datatype trial = Complete of (RVar.var * RVar.value) list
		   | Partial of (RVar.var * RVar.value) list
              

    (* makeLearner : Graphical model * observed_vars * ...
			     -> learner *)
    val makeLearner : (GModel.gmodel * RVar.var list) -> learner

    val learn : (learner * parameters * trial) -> parameters


end
