(* D_CPD : A discrete conditional probiblity distribution

  This module provides the specification of discrete CPDs.
*) 

signature D_CPD =
sig
    structure RVar : D_R_VAR

    type cpd

    val make : real list * RVar.var * RVar.var list -> cpd

    val getChild : cpd -> RVar.var

    val getParents : cpd -> RVar.var list

    val getEntries : cpd -> real list

end
