(* DLOCAL_FACTOR : Interface for discrete local factor descriptions.

  This module provides the specification of discrete local factors.
 *) 
signature D_LOCAL_FACTOR = 
sig
    structure RVar : D_R_VAR
    structure CPD : D_CPD 
    structure Potential : D_POTENTIAL 
    structure IPotential : D_IPOTENTIAL
    (* All structures must operate on the same implemntation of RVs *)
    sharing CPD.RVar = Potential.RVar = IPotential.RVar = RVar

    (* A local factor is a union of all available options *)
    datatype factor = CPD of CPD.cpd
		    | Potential of Potential.pot
				   
    val scope : factor -> RVar.var list

    val toIPotential : factor -> IPotential.ipot

end
