(* DLocalFactor: A functor which implements of the DLOCAL_FACTOR
                 interface.  
*)

functor DLocalFactorFn(structure RVar : D_R_VAR
		       structure CPD : D_CPD
		       structure Potential : D_POTENTIAL
		       structure IPotential : D_IPOTENTIAL
		       sharing CPD.RVar = Potential.RVar 
			     = IPotential.RVar = RVar) 
	:> D_LOCAL_FACTOR where RVar = RVar 
                       and CPD = CPD 
		       and Potential = Potential 
		       and IPotential = IPotential =
struct

structure RVar = RVar
structure CPD = CPD 
structure Potential = Potential 
structure IPotential = IPotential 

datatype factor = CPD of CPD.cpd
		| Potential of Potential.pot

fun scope (CPD cpd) = (CPD.getChild cpd) :: (CPD.getParents cpd)
  | scope (Potential pot) = Potential.getScope pot

fun toIPotential (CPD cpd) = IPotential.make(scope (CPD cpd),
					     CPD.getEntries cpd)
  | toIPotential (Potential pot) = IPotential.make(scope (Potential pot),
						   Potential.getEntries pot)
end
