(* D_R_VAR : Interface for A Discrete Random Variable.

   Currently this has minimal functionality, basically managing
   variable id's and dimension. It is expected that will be
   suplemented (adding priors?) for learning.

*)

signature D_R_VAR =
sig
    include R_VAR

    (* make : id * dimension -> var 
       Create a RV. *)
    val make : int * int -> var

    (* newVar : dimension -> new_rvar 
      Make a RV without specifing an id. *)
    val newVar : int -> var

    (* dim : rvar -> dimension
       Get the dimensions of the RV. *)
    val dim : var -> int 

    (* id : rvar -> id
       Get the unique id of the RV. *)
    val id : var -> int  

    (* value : value -> index 
       Return integer representaion of a value between 0 and dim *)
    val valueToInt : value -> int 
    val intToValue : int -> value

    val giveName : var -> string -> unit
end
