structure DRVar :> D_R_VAR =  
struct

(* type var = int * int * (int -> string) 
     (Unique Id * Dimension *)
type var = int * int 

type value = int   (* A discrete var takes on integer values *)

val next_id = ref 0 (* maintain the next unique id to be given out. This can 
                       be sidesteped by specefing an id in make *)

fun newVar (dim) = let val _ = next_id := !next_id + 1 in (!next_id,dim) end 

fun make (id,dim) = (id,dim)

(* basicToString : uninformed var to string conversation *)
fun basicToString (id,dim) = 
    "(" ^ (Int.toString id) ^","^(Int.toString dim)^")"

(* lookupVar : The global string lookup function. This is modified
  at runtime if and when new variables register a printing function. *)
val lookupVar = ref basicToString

(* giveName : Add to the lookup table. *)
fun giveName var string = lookupVar := (let val oldLookup = !lookupVar
					in fn var' => 
					      if var = var' then string
					      else oldLookup var'
					end)
fun toString var = (!lookupVar) var
							   
fun valueToInt v = v
fun intToValue v = v

fun dim (id,dim) = dim

fun id (id,dim) = id

fun compare ((id1,_),(id2,_)) = Int.compare(id1,id2)

end
