(* R_VAR : Interface for a general random variable. 

  This signature is ment to a general random variable, and so it only
 specifies the minimal set of functionality. More specific random
 variables (exponential, discrete, etc.)  should extend, by means of
 include, this signature.

*) 

signature R_VAR = sig

    eqtype var   (* A random variable, Only the exact same RVs are equal *)
    type value   (* The type of an *instance* of the RV. Likely ints for 
		     discrete, real for exponential, etc. *)

    (* compare : (v1,v2) -> result 
       Compare two RV's based on id's. This is useful for soring, maitaining 
       a set, etc. *)
    val compare : var*var -> order

    (* toString : var -> string representation 
       For printing. *)			 
    val toString : var -> string
end
