functor TesterFn() :> TESTER =
struct
(* structure Out = Control.Print *)
(*  (testname, testfunction) list * group name *)
type tester = (string* (unit -> bool) ) list * string

val tester = ref ([], "Default") : tester ref

fun setName group_name = 
    let val (tests,_) = !tester
    in
	tester := (tests, group_name)
    end

fun addTest s f = 
    let 
	val (tests, name) = !tester
    in
	tester := ((s,f) :: tests, name)
    end

fun runTests () =
    let
	val (tests, group_name) = !tester
	val _ = print ("Running test group : " ^ group_name ^ " \n" )

	val count = List.foldr (fn ((s,f),num_passed) =>
				   let val _ = print  ("  " ^ s)
				   in if f () 
				      then num_passed+1 
					   before print " passed.\n"
				      else num_passed 
					   before print " FAILED!\n"
				   end)
			       0 tests
	val _ = print (" passed " ^ (Int.toString count ) 
		^ " of " ^ (Int.toString (List.length tests)) ^ ".\n\n")
    in
	List.length tests = count
    end

end

