(* miscellaneous stuff goes here *)
structure Util = 
struct

exception AssertError

fun assert e = if e then () else raise AssertError
fun approxEq eps r r' = Real.<(Real.abs(r-r'),eps)


fun member e ls = List.exists (fn x=>x=e) ls

(* A few set structures *)
structure IntSet = ListSetFn(struct 
			     type ord_key = int
			     val compare = Int.compare
			     end)
structure IntSetSet = ListSetFn(struct 
				type ord_key = IntSet.set
				val compare = IntSet.compare
				end)
 (* Sorting *)
val sorted = ListMergeSort.sorted 
val sort = ListMergeSort.sort 
fun findMin f (x::xs) = List.foldr (fn (e,acc)=>if f(e,acc) then e else acc) 
				   x xs

(* pop-up a display on a dot-file.
    - requires dot, gv
*)
val ps_viewer = ref "gv"
val dot = ref "dot"
fun showDot dot_string =
    let
	val dot_file = "temp.dot"
	val dot_outstream = TextIO.openOut dot_file
	val output_ps = "temp.ps"
	val _ = TextIO.output(dot_outstream,  dot_string)
	val _ = TextIO.closeOut dot_outstream
	val _ = OS.Process.system (!dot ^ " -Tps " ^ dot_file 
				   ^ " -o " ^ output_ps)
	val child = Posix.Process.fork()
    in
	if child = NONE
	then
	    OS.Process.exit 
		(OS.Process.system (!ps_viewer ^ " " ^ output_ps))
        else
            ignore (Posix.Process.sleep (Time.fromReal 1.0))(* HACK *)
    end

end
